Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 3680)
@@ -1,5 +1,5 @@
 MODULE trcnam_pisces
    !!======================================================================
-   !!                      ***  MODULE trcnam_lobster  ***
+   !!                      ***  MODULE trcnam_pisces  ***
    !! TOP :   initialisation of some run parameters for PISCES bio-model
    !!======================================================================
@@ -9,5 +9,5 @@
    !!             2.0  !  2007-12  (C. Ethe, G. Madec) from trcnam.pisces.h90
    !!----------------------------------------------------------------------
-#if defined key_pisces
+#if defined key_pisces || defined key_pisces_reduced
    !!----------------------------------------------------------------------
    !!   'key_pisces'   :                                   PISCES bio-model
@@ -19,4 +19,5 @@
    USE trc             ! TOP variables
    USE sms_pisces      ! sms trends
+   USE trdmod_trc_oce
    USE iom             ! I/O manager
 
@@ -48,64 +49,26 @@
       !!
       INTEGER :: jl, jn
-      TYPE(DIAG), DIMENSION(jp_pisces_2d) :: pisdia2d
-      TYPE(DIAG), DIMENSION(jp_pisces_3d) :: pisdia3d
+      TYPE(DIAG), DIMENSION(jp_pisces_2d)  :: pisdia2d
+      TYPE(DIAG), DIMENSION(jp_pisces_3d)  :: pisdia3d
+      TYPE(DIAG), DIMENSION(jp_pisces_trd) :: pisdiabio
+      CHARACTER(LEN=20)   ::   clname
       !!
-      NAMELIST/nampisbio/ nrdttrc, wsbio, xkmort, ferat3, wsbio2
-#if defined key_kriest
-      NAMELIST/nampiskrp/ xkr_eta, xkr_zeta, xkr_mass_min, xkr_mass_max
+      NAMELIST/nampisdia/ pisdia3d, pisdia2d     ! additional diagnostics
+#if defined key_pisces_reduced
+      NAMELIST/nampisdbi/ pisdiabio
 #endif
-      NAMELIST/nampisdia/ pisdia3d, pisdia2d     ! additional diagnostics
-      NAMELIST/nampisdmp/ ln_pisdmp, nn_pisdmp, ln_pisclo
 
       !!----------------------------------------------------------------------
 
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' trc_nam_pisces : read PISCES namelists'
+      clname = 'namelist_pisces'
+#if defined key_pisces
+      IF(lwp) WRITE(numout,*) ' trc_nam_pisces : read PISCES namelist'
+#else
+      IF(lwp) WRITE(numout,*) ' trc_nam_pisces : read LOBSTER namelist'
+#endif
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+      CALL ctl_opn( numnatp, TRIM( clname ), 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
 
-
-      !                               ! Open the namelist file
-      !                               ! ----------------------
-      CALL ctl_opn( numnatp, 'namelist_pisces', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
-
-      REWIND( numnatp )                    
-      READ  ( numnatp, nampisbio )
-
-      IF(lwp) THEN                         ! control print
-         WRITE(numout,*) ' Namelist : nampisbio'
-         WRITE(numout,*) '    frequence pour la biologie                nrdttrc   =', nrdttrc
-         WRITE(numout,*) '    POC sinking speed                         wsbio     =', wsbio
-         WRITE(numout,*) '    half saturation constant for mortality    xkmort    =', xkmort
-         WRITE(numout,*) '    Fe/C in zooplankton                       ferat3    =', ferat3
-         WRITE(numout,*) '    Big particles sinking speed               wsbio2    =', wsbio2
-      ENDIF
-
-#if defined key_kriest
-
-      !                               ! nampiskrp : kriest parameters
-      !                               ! -----------------------------
-      xkr_eta      = 0.62        
-      xkr_zeta     = 1.62        
-      xkr_mass_min = 0.0002     
-      xkr_mass_max = 1.      
-
-      REWIND( numnatp )                     ! read natkriest
-      READ  ( numnatp, nampiskrp )
-
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : nampiskrp'
-         WRITE(numout,*) '    Sinking  exponent                        xkr_eta      = ', xkr_eta
-         WRITE(numout,*) '    N content exponent                       xkr_zeta     = ', xkr_zeta
-         WRITE(numout,*) '    Minimum mass for Aggregates              xkr_mass_min = ', xkr_mass_min
-         WRITE(numout,*) '    Maximum mass for Aggregates              xkr_mass_max = ', xkr_mass_max
-         WRITE(numout,*)
-     ENDIF
-
-
-     ! Computation of some variables
-     xkr_massp = 5.7E-6 * 7.6 * xkr_mass_min**xkr_zeta
-
-#endif
       !
       IF( .NOT.lk_iomput .AND. ln_diatrc ) THEN
@@ -162,15 +125,43 @@
       ENDIF
 
-      REWIND( numnatp )
-      READ  ( numnatp, nampisdmp )
+#if defined key_pisces_reduced
 
-      IF(lwp) THEN                         ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : nampisdmp'
-         WRITE(numout,*) '    Relaxation of tracer to glodap mean value             ln_pisdmp      =', ln_pisdmp
-         WRITE(numout,*) '    Frequency of Relaxation                               nn_pisdmp      =', nn_pisdmp
-         WRITE(numout,*) '    Restoring of tracer to initial value  on closed seas  ln_pisclo      =', ln_pisclo
-         WRITE(numout,*) ' '
-      ENDIF
+      IF( ( .NOT.lk_iomput .AND. ln_diabio ) .OR. lk_trdmld_trc ) THEN
+         !
+         ! Namelist nampisdbi
+         ! -------------------
+         DO jl = 1, jp_pisces_trd
+            IF(     jl <  10 ) THEN   ;   WRITE (pisdiabio(jl)%sname,'("BIO_",I1)') jl      ! short name
+            ELSEIF (jl < 100 ) THEN   ;   WRITE (pisdiabio(jl)%sname,'("BIO_",I2)') jl
+            ELSE                      ;   WRITE (pisdiabio(jl)%sname,'("BIO_",I3)') jl
+            ENDIF
+            WRITE(pisdiabio(jl)%lname,'("BIOLOGICAL TREND NUMBER ",I2)') jl                 ! long name
+            pisdiabio(jl)%units = 'mmoleN/m3/s '                                            ! units
+         END DO
+
+         REWIND( numnatp )
+         READ  ( numnatp, nampisdbi )
+
+         DO jl = 1, jp_pisces_trd
+            jn = jp_pcs0_trd + jl - 1
+            ctrbio(jl) = pisdiabio(jl)%sname
+            ctrbil(jl) = pisdiabio(jl)%lname
+            ctrbiu(jl) = pisdiabio(jl)%units
+         END DO
+
+         IF(lwp) THEN                   ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) ' Namelist : nampisdbi'
+            DO jl = 1, jp_pisces_trd
+               jn = jp_pcs0_trd + jl - 1
+               WRITE(numout,*) '  biological trend No : ', jn, '    short name : ', ctrbio(jn), &
+                 &             '  long name  : ', ctrbio(jn), '   unit : ', ctrbio(jn)
+            END DO
+            WRITE(numout,*) ' '
+         END IF
+         !
+      END IF
+
+#endif
 
    END SUBROUTINE trc_nam_pisces
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 3680)
@@ -7,5 +7,5 @@
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
    !!----------------------------------------------------------------------
-#if defined key_pisces
+#if defined key_pisces || defined key_pisces_reduced
    !!----------------------------------------------------------------------
    !!   'key_pisces'                                       PISCES bio-model
@@ -13,17 +13,7 @@
    !!   trcsms_pisces        :  Time loop of passive tracers sms
    !!----------------------------------------------------------------------
-   USE oce_trc         !  shared variables between ocean and passive tracers
-   USE trc             !  passive tracers common variables 
-   USE sms_pisces      !  PISCES Source Minus Sink variables
-   USE p4zbio          !  Biological model
-   USE p4zche          !  Chemical model
-   USE p4zlys          !  Calcite saturation
-   USE p4zflx          !  Gas exchange
-   USE p4zsed          !  Sedimentation
-   USE p4zint          !  time interpolation
-   USE trdmod_oce      !  Ocean trends variables
-   USE trdmod_trc      !  TOP trends variables
-   USE sedmodel        !  Sediment model
-   USE prtctl_trc      !  print control for debugging
+   USE par_pisces
+   USE p4zsms
+   USE p2zsms
 
    IMPLICIT NONE
@@ -31,11 +21,4 @@
 
    PUBLIC   trc_sms_pisces    ! called in trcsms.F90
-
-   LOGICAL ::  ln_check_mass = .false.       !: Flag to check mass conservation 
-
-   INTEGER ::  numno3  !: logical unit for NO3 budget
-   INTEGER ::  numalk  !: logical unit for talk budget
-   INTEGER ::  numsil  !: logical unit for Si budget
-
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
@@ -46,4 +29,11 @@
 CONTAINS
 
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE trc_ini_pisces ***
+      !!
+      !! ** Purpose :   Initialisation of the PISCES biochemical model
+      !!----------------------------------------------------------------------
+
+
    SUBROUTINE trc_sms_pisces( kt )
       !!---------------------------------------------------------------------
@@ -51,197 +41,16 @@
       !!
       !! ** Purpose :   Managment of the call to Biological sources and sinks 
-      !!              routines of PISCES bio-model
-      !!
-      !! ** Method  : - at each new day ...
-      !!              - several calls of bio and sed ???
-      !!              - ...
-      !!---------------------------------------------------------------------
-      !
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
-      !!
-      INTEGER ::   jnt, jn, jl
-      CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:,:)  :: ztrdpis
-      !!---------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('trc_sms_pisces')
-      !
-      IF( ln_pisdmp .AND. MOD( kt - nn_dttrc, nn_pisdmp ) == 0 )   CALL trc_sms_pisces_dmp( kt )  ! Relaxation of some tracers
-                                                                   CALL trc_sms_pisces_mass_conserv( kt ) ! Mass conservation checking
-      IF( l_trdtrc )  THEN
-         CALL wrk_alloc( jpi, jpj, jpk, jp_pisces, ztrdpis ) 
-         DO jn = 1, jp_pisces
-            jl = jn + jp_pcs0 - 1
-            ztrdpis(:,:,:,jn) = trn(:,:,:,jl)
-         ENDDO
-      ENDIF
-
-      IF( ndayflxtr /= nday_year ) THEN      ! New days
-         !
-         ndayflxtr = nday_year
-
-         IF(lwp) write(numout,*)
-         IF(lwp) write(numout,*) ' New chemical constants and various rates for biogeochemistry at new day : ', nday_year
-         IF(lwp) write(numout,*) '~~~~~~'
-
-         CALL p4z_che              ! computation of chemical constants
-         CALL p4z_int              ! computation of various rates for biogeochemistry
-         !
-      ENDIF
-
-
-      DO jnt = 1, nrdttrc          ! Potential time splitting if requested
-         !
-         CALL p4z_bio (kt, jnt)    ! Compute soft tissue production (POC)
-         CALL p4z_sed (kt, jnt)    ! compute soft tissue remineralisation
-         !
-         DO jn = jp_pcs0, jp_pcs1
-            trb(:,:,:,jn) = trn(:,:,:,jn)
-         ENDDO
-         !
-      END DO
-
-      IF( l_trdtrc )  THEN
-         DO jn = 1, jp_pisces
-            jl = jn + jp_pcs0 - 1
-            ztrdpis(:,:,:,jn) = ( ztrdpis(:,:,:,jn) - trn(:,:,:,jl) ) * rfact2r
-         ENDDO
-      ENDIF
-
-      CALL p4z_lys( kt )             ! Compute CaCO3 saturation
-      CALL p4z_flx( kt )             ! Compute surface fluxes
-
-      DO jn = jp_pcs0, jp_pcs1
-        CALL lbc_lnk( trn(:,:,:,jn), 'T', 1. )
-        CALL lbc_lnk( trb(:,:,:,jn), 'T', 1. )
-        CALL lbc_lnk( tra(:,:,:,jn), 'T', 1. )
-      END DO
-
-      IF( l_trdtrc ) THEN
-         DO jn = 1, jp_pisces
-            jl = jn + jp_pcs0 - 1
-             ztrdpis(:,:,:,jn) = ztrdpis(:,:,:,jn) + tra(:,:,:,jl)
-             CALL trd_mod_trc( ztrdpis(:,:,:,jn), jn, jptra_trd_sms, kt )   ! save trends
-          END DO
-          CALL wrk_dealloc( jpi, jpj, jpk, jp_pisces, ztrdpis ) 
-      END IF
-
-      IF( lk_sed ) THEN 
-         !
-         CALL sed_model( kt )     !  Main program of Sediment model
-         !
-         DO jn = jp_pcs0, jp_pcs1
-           CALL lbc_lnk( trn(:,:,:,jn), 'T', 1. )
-         END DO
-         !
-      ENDIF
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('trc_sms_pisces')
-      !
-   END SUBROUTINE trc_sms_pisces
-
-   SUBROUTINE trc_sms_pisces_dmp( kt )
-      !!----------------------------------------------------------------------
-      !!                    ***  trc_sms_pisces_dmp  ***
-      !!
-      !! ** purpose  : Relaxation of some tracers
-      !!----------------------------------------------------------------------
-      !
-      INTEGER, INTENT( in )  ::     kt ! time step
-      !
-      REAL(wp) ::  alkmean = 2426.     ! mean value of alkalinity ( Glodap ; for Goyet 2391. )
-      REAL(wp) ::  po4mean = 2.165     ! mean value of phosphates
-      REAL(wp) ::  no3mean = 30.90     ! mean value of nitrate
-      REAL(wp) ::  silmean = 91.51     ! mean value of silicate
-      !
-      REAL(wp) :: zarea, zalksum, zpo4sum, zno3sum, zsilsum
-      !!---------------------------------------------------------------------
-
-
-      IF(lwp)  WRITE(numout,*)
-      IF(lwp)  WRITE(numout,*) ' trc_sms_pisces_dmp : Relaxation of nutrients at time-step kt = ', kt
-      IF(lwp)  WRITE(numout,*)
-
-      IF( cp_cfg == "orca" .AND. .NOT. lk_c1d ) THEN      ! ORCA condiguration (not 1D) !
-         !                                                    ! --------------------------- !
-         ! set total alkalinity, phosphate, nitrate & silicate
-         zarea          = 1._wp / glob_sum( cvol(:,:,:) ) * 1e6              
-
-         zalksum = glob_sum( trn(:,:,:,jptal) * cvol(:,:,:)  ) * zarea
-         zpo4sum = glob_sum( trn(:,:,:,jppo4) * cvol(:,:,:)  ) * zarea / 122.
-         zno3sum = glob_sum( trn(:,:,:,jpno3) * cvol(:,:,:)  ) * zarea / 7.6
-         zsilsum = glob_sum( trn(:,:,:,jpsil) * cvol(:,:,:)  ) * zarea
- 
-         IF(lwp) WRITE(numout,*) '       TALK mean : ', zalksum
-         trn(:,:,:,jptal) = trn(:,:,:,jptal) * alkmean / zalksum
-
-         IF(lwp) WRITE(numout,*) '       PO4  mean : ', zpo4sum
-         trn(:,:,:,jppo4) = trn(:,:,:,jppo4) * po4mean / zpo4sum
-
-         IF(lwp) WRITE(numout,*) '       NO3  mean : ', zno3sum
-         trn(:,:,:,jpno3) = trn(:,:,:,jpno3) * no3mean / zno3sum
-
-         IF(lwp) WRITE(numout,*) '       SiO3 mean : ', zsilsum
-         trn(:,:,:,jpsil) = MIN( 400.e-6,trn(:,:,:,jpsil) * silmean / zsilsum )
-         !
-      ENDIF
-
-   END SUBROUTINE trc_sms_pisces_dmp
-
-   SUBROUTINE trc_sms_pisces_mass_conserv ( kt )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE trc_sms_pisces_mass_conserv  ***
-      !!
-      !! ** Purpose :  Mass conservation check 
+      !!                routines of PISCES or LOBSTER bio-model
       !!
       !!---------------------------------------------------------------------
       !
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
-      !!
-      REAL(wp) :: zalkbudget, zno3budget, zsilbudget
+      !!---------------------------------------------------------------------
       !
-      NAMELIST/nampismass/ ln_check_mass
-      !!---------------------------------------------------------------------
-
-      IF( kt == nittrc000 ) THEN 
-         REWIND( numnatp )       
-         READ  ( numnatp, nampismass )
-         IF(lwp) THEN                         ! control print
-            WRITE(numout,*) ' '
-            WRITE(numout,*) ' Namelist parameter for mass conservation checking'
-            WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
-            WRITE(numout,*) '    Flag to check mass conservation of NO3/Si/TALK ln_check_mass = ', ln_check_mass
-         ENDIF
-
-         IF( ln_check_mass .AND. lwp) THEN      !   Open budget file of NO3, ALK, Si
-            CALL ctl_opn( numno3, 'no3.budget' , 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, 6, .FALSE., narea )
-            CALL ctl_opn( numsil, 'sil.budget' , 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, 6, .FALSE., narea )
-            CALL ctl_opn( numalk, 'talk.budget', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, 6, .FALSE., narea )
-         ENDIF
+      IF( lk_p4z ) THEN  ;   CALL p4z_sms( kt )   !  PISCES
+      ELSE               ;   CALL p2z_sms( kt )   !  LOBSTER
       ENDIF
-
-      IF( ln_check_mass ) THEN      !   Compute the budget of NO3, ALK, Si
-         zno3budget = glob_sum( (   trn(:,:,:,jpno3) + trn(:,:,:,jpnh4)  &
-            &                     + trn(:,:,:,jpphy) + trn(:,:,:,jpdia)  &
-            &                     + trn(:,:,:,jpzoo) + trn(:,:,:,jpmes)  &
-            &                     + trn(:,:,:,jppoc) + trn(:,:,:,jpgoc)  &
-            &                     + trn(:,:,:,jpdoc)                     ) * cvol(:,:,:)  ) 
-         ! 
-         zsilbudget = glob_sum( (   trn(:,:,:,jpsil) + trn(:,:,:,jpgsi)  &
-            &                     + trn(:,:,:,jpdsi)                     ) * cvol(:,:,:)  )
-         ! 
-         zalkbudget = glob_sum( (   trn(:,:,:,jpno3) * rno3              &
-            &                     + trn(:,:,:,jptal)                     &
-            &                     + trn(:,:,:,jpcal) * 2.                ) * cvol(:,:,:)  )
-
-         IF( lwp ) THEN
-            WRITE(numno3,9500) kt,  zno3budget / areatot
-            WRITE(numsil,9500) kt,  zsilbudget / areatot
-            WRITE(numalk,9500) kt,  zalkbudget / areatot
-         ENDIF
-       ENDIF
- 9500  FORMAT(i10,e18.10)     
-       !
-   END SUBROUTINE trc_sms_pisces_mass_conserv
+      !
+   END SUBROUTINE trc_sms_pisces
 
 #else
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/trcwri_pisces.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/trcwri_pisces.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/trcwri_pisces.F90	(revision 3680)
@@ -6,11 +6,12 @@
    !! History :   1.0  !  2009-05 (C. Ethe)  Original code
    !!----------------------------------------------------------------------
-#if defined key_top && key_pisces && defined key_iomput
+#if defined key_top && defined key_iomput && ( defined key_pisces || defined key_pisces_reduced )
    !!----------------------------------------------------------------------
-   !!   'key_pisces'                                           PISCES model
+   !!   'key_pisces or key_pisces_reduced'                     PISCES model
    !!----------------------------------------------------------------------
    !! trc_wri_pisces   :  outputs of concentration fields
    !!----------------------------------------------------------------------
    USE trc         ! passive tracers common variables 
+   USE sms_pisces  ! PISCES variables
    USE iom         ! I/O manager
 
@@ -35,11 +36,18 @@
       ! write the tracer concentrations in the file
       ! ---------------------------------------
-      DO jn = 1, jptra
-         zrfact = 1.0e+6 
-         IF( jn == jpno3 .OR. jn == jpnh4 ) zrfact = 1.0e+6 / 7.6
-         IF( jn == jppo4  )                 zrfact = 1.0e+6 / 122.
+#if defined key_pisces_reduced
+      DO jn = jp_pcs0, jp_pcs1
          cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
          CALL iom_put( cltra, trn(:,:,:,jn) * zrfact )
       END DO
+#else
+      DO jn = jp_pcs0, jp_pcs1
+         zrfact = 1.0e+6 
+         IF( jn == jpno3 .OR. jn == jpnh4 ) zrfact = rno3 * 1.0e+6 
+         IF( jn == jppo4  )                 zrfact = po4r * 1.0e+6
+         cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
+         CALL iom_put( cltra, trn(:,:,:,jn) * zrfact )
+      END DO
+#endif
       !
    END SUBROUTINE trc_wri_pisces
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 3680)
@@ -82,13 +82,13 @@
       IF( kt == nittrc000 )   CALL trc_adv_ctl          ! initialisation & control of options
 
-#if ! defined key_pisces
-      IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nittrc000
-         r2dt(:) =  rdttrc(:)           ! = rdttrc (restarting with Euler time stepping)
-      ELSEIF( kt <= nittrc000 + 1 ) THEN          ! at nittrc000 or nittrc000+1
-         r2dt(:) = 2. * rdttrc(:)       ! = 2 rdttrc (leapfrog)
+      IF( ln_top_euler) THEN
+         r2dt(:) =  rdttrc(:)              ! = rdttrc (use Euler time stepping)
+      ELSE
+         IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nittrc000
+            r2dt(:) =  rdttrc(:)           ! = rdttrc (restarting with Euler time stepping)
+         ELSEIF( kt <= nittrc000 + 1 ) THEN          ! at nittrc000 or nittrc000+1
+            r2dt(:) = 2. * rdttrc(:)       ! = 2 rdttrc (leapfrog)
+         ENDIF
       ENDIF
-#else
-      r2dt(:) =  rdttrc(:)              ! = rdttrc (for PISCES use Euler time stepping)
-#endif
 
       !                                                   ! effective transport
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcnam_trp.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcnam_trp.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcnam_trp.F90	(revision 3680)
@@ -81,5 +81,5 @@
       NAMELIST/namtrc_rad/ ln_trcrad
 #if defined key_trcdmp
-      NAMELIST/namtrc_dmp/ nn_hdmp_tr, nn_zdmp_tr, rn_surf_tr, &
+      NAMELIST/namtrc_dmp/ ln_trcdmp, nn_hdmp_tr, nn_zdmp_tr, rn_surf_tr, &
         &                  rn_bot_tr , rn_dep_tr , nn_file_tr
 #endif
@@ -156,4 +156,5 @@
          WRITE(numout,*) '~~~~~~~'
          WRITE(numout,*) '   Namelist namtrc_dmp : set damping parameter'
+         WRITE(numout,*) '      add a damping term or not      ln_trcdmp = ', ln_trcdmp
          WRITE(numout,*) '      tracer damping option          nn_hdmp_tr = ', nn_hdmp_tr
          WRITE(numout,*) '      mixed layer damping option     nn_zdmp_tr = ', nn_zdmp_tr, '(zoom: forced to 0)'
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 3680)
@@ -34,5 +34,4 @@
    USE tranxt
 # if defined key_agrif
-   USE agrif_top_update
    USE agrif_top_interp
 # endif
@@ -146,9 +145,4 @@
       ENDIF
 
-#if defined key_agrif
-      ! Update tracer at AGRIF zoom boundaries
-      IF( .NOT.Agrif_Root() )    CALL Agrif_Update_Trc( kt )      ! children only
-#endif      
-
       ! trends computation
       IF( l_trdtrc ) THEN                                      ! trends
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 3680)
@@ -63,5 +63,4 @@
       IF( lk_cfc     )   CALL trc_rad_sms( kt, trb, trn, jp_cfc0 , jp_cfc1               )  ! CFC model
       IF( lk_c14b    )   CALL trc_rad_sms( kt, trb, trn, jp_c14b0, jp_c14b1              )  ! bomb C14
-      IF( lk_lobster )   CALL trc_rad_sms( kt, trb, trn, jp_lob0 , jp_lob1, cpreserv='Y' )  ! LOBSTER model
       IF( lk_pisces  )   CALL trc_rad_sms( kt, trb, trn, jp_pcs0 , jp_pcs1, cpreserv='Y' )  ! PISCES model
       IF( lk_my_trc  )   CALL trc_rad_sms( kt, trb, trn, jp_myt0 , jp_myt1               )  ! MY_TRC model
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 3680)
@@ -50,5 +50,5 @@
       !!            tra = tra + emp * trn / e3t   for k=1
       !!         where emp, the surface freshwater budget (evaporation minus
-      !!         precipitation minus runoff) given in kg/m2/s is divided
+      !!         precipitation ) given in kg/m2/s is divided
       !!         by 1035 kg/m3 (density of ocean water) to obtain m/s.
       !!
@@ -79,17 +79,12 @@
       ENDIF
 
+      ! Coupling online : river runoff is added to the horizontal divergence (hdivn) in the subroutine sbc_rnf_div 
+      ! one only consider the concentration/dilution effect due to evaporation minus precipitation + freezing/melting of sea-ice
 
-      IF( lk_offline ) THEN          ! sfx in dynamical files contains sfx  - rnf
-         zsfx(:,:) = sfx(:,:)  
-      ELSE                           ! Concentration dilution effect on tracer due to evaporation, precipitation, and river runoff
-         IF( lk_vvl ) THEN                      ! volume variable
-            zsfx(:,:) = sfx(:,:) - emp(:,:)   
-!!ch         zsfx(:,:) = 0.
-         ELSE                                   ! linear free surface
-            IF( ln_rnf ) THEN  ;  zsfx(:,:) = sfx(:,:) - rnf(:,:)   !  E-P-R
-            ELSE               ;  zsfx(:,:) = sfx(:,:)
-            ENDIF 
-         ENDIF 
-      ENDIF 
+      IF( .NOT. lk_offline .AND. lk_vvl ) THEN  ! online coupling + volume variable
+         zemps(:,:) = sfx(:,:) - emp(:,:)
+      ELSE
+         zemps(:,:) = emp(:,:)
+      ENDIF
 
       ! 0. initialization
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 3680)
@@ -29,5 +29,6 @@
 
 #if defined key_agrif
-   USE agrif_top_sponge ! Momemtum and tracers sponges
+   USE agrif_top_sponge ! tracers sponges
+   USE agrif_top_update ! tracers updates
 #endif
 
@@ -76,4 +77,8 @@
                                 CALL trc_nxt( kstp )            ! tracer fields at next time step     
          IF( ln_trcrad )        CALL trc_rad( kstp )            ! Correct artificial negative concentrations
+
+#if defined key_agrif
+      IF( .NOT. Agrif_Root())   CALL Agrif_Update_Trc( kstp )   ! Update tracer at AGRIF zoom boundaries : children only
+#endif
          IF( ln_zps    )        CALL zps_hde( kstp, jptra, trn, gtru, gtrv )  ! Partial steps: now horizontal gradient of passive
                                                                 ! tracers at the bottom ocean level
@@ -98,7 +103,7 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE trc_trp( kt )              ! Empty routine
-      INTEGER, INTENT(in) ::   kt
-      WRITE(*,*) 'trc_trp: You should not have seen this print! error?', kt
+   SUBROUTINE trc_trp( kstp )              ! Empty routine
+      INTEGER, INTENT(in) ::   kstp
+      WRITE(*,*) 'trc_trp: You should not have seen this print! error?', kstp
    END SUBROUTINE trc_trp
 #endif
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 3680)
@@ -73,13 +73,13 @@
       IF( kt == nittrc000 )   CALL zdf_ctl          ! initialisation & control of options
 
-#if ! defined key_pisces
-      IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nittrc000
-         r2dt(:) =  rdttrc(:)           ! = rdttrc (restarting with Euler time stepping)
-      ELSEIF( kt <= nittrc000 + 1 ) THEN          ! at nittrc000 or nittrc000+1
-         r2dt(:) = 2. * rdttrc(:)       ! = 2 rdttrc (leapfrog)
+      IF( ln_top_euler) THEN
+         r2dt(:) =  rdttrc(:)              ! = rdttrc (use Euler time stepping)
+      ELSE
+         IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nittrc000
+            r2dt(:) =  rdttrc(:)           ! = rdttrc (restarting with Euler time stepping)
+         ELSEIF( kt <= nittrc000 + 1 ) THEN          ! at nittrc000 or nittrc000+1
+            r2dt(:) = 2. * rdttrc(:)       ! = 2 rdttrc (leapfrog)
+         ENDIF
       ENDIF
-#else
-      r2dt(:) =  rdttrc(:)              ! = rdttrc (for PISCES use Euler time stepping)
-#endif
 
       IF( l_trdtrc )  THEN
